package org.jeecg.modules.fbsQualityQualificationRate.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsQualityQualificationRate.entity.FbsQualityQualificationRate;
import org.jeecg.modules.fbsQualityQualificationRate.service.IFbsQualityQualificationRateService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 品质看板合格率统计表格数据
 * @author： jeecg-boot
 * @date：   2020-11-03
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsQualityQualificationRate/fbsQualityQualificationRate")
@Slf4j
public class FbsQualityQualificationRateController {
	@Autowired
	private IFbsQualityQualificationRateService fbsQualityQualificationRateService;
	
	/**
	  * 分页列表查询
	 * @param fbsQualityQualificationRate
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsQualityQualificationRate>> queryPageList(FbsQualityQualificationRate fbsQualityQualificationRate,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsQualityQualificationRate>> result = new Result<IPage<FbsQualityQualificationRate>>();
		QueryWrapper<FbsQualityQualificationRate> queryWrapper = QueryGenerator.initQueryWrapper(fbsQualityQualificationRate, req.getParameterMap());
		Page<FbsQualityQualificationRate> page = new Page<FbsQualityQualificationRate>(pageNo, pageSize);
		IPage<FbsQualityQualificationRate> pageList = fbsQualityQualificationRateService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsQualityQualificationRate
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsQualityQualificationRate> add(@RequestBody FbsQualityQualificationRate fbsQualityQualificationRate) {
		Result<FbsQualityQualificationRate> result = new Result<FbsQualityQualificationRate>();
		try {
			fbsQualityQualificationRateService.save(fbsQualityQualificationRate);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsQualityQualificationRate
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsQualityQualificationRate> edit(@RequestBody FbsQualityQualificationRate fbsQualityQualificationRate) {
		Result<FbsQualityQualificationRate> result = new Result<FbsQualityQualificationRate>();
		FbsQualityQualificationRate fbsQualityQualificationRateEntity = fbsQualityQualificationRateService.getById(fbsQualityQualificationRate.getId());
		if(fbsQualityQualificationRateEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsQualityQualificationRateService.updateById(fbsQualityQualificationRate);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsQualityQualificationRate> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsQualityQualificationRate> result = new Result<FbsQualityQualificationRate>();
		FbsQualityQualificationRate fbsQualityQualificationRate = fbsQualityQualificationRateService.getById(id);
		if(fbsQualityQualificationRate==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsQualityQualificationRateService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsQualityQualificationRate> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsQualityQualificationRate> result = new Result<FbsQualityQualificationRate>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsQualityQualificationRateService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsQualityQualificationRate> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsQualityQualificationRate> result = new Result<FbsQualityQualificationRate>();
		FbsQualityQualificationRate fbsQualityQualificationRate = fbsQualityQualificationRateService.getById(id);
		if(fbsQualityQualificationRate==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsQualityQualificationRate);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsQualityQualificationRate> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsQualityQualificationRate fbsQualityQualificationRate = JSON.parseObject(deString, FbsQualityQualificationRate.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsQualityQualificationRate, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsQualityQualificationRate> pageList = fbsQualityQualificationRateService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "品质看板合格率统计表格数据列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsQualityQualificationRate.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("品质看板合格率统计表格数据列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsQualityQualificationRate> listFbsQualityQualificationRates = ExcelImportUtil.importExcel(file.getInputStream(), FbsQualityQualificationRate.class, params);
              for (FbsQualityQualificationRate fbsQualityQualificationRateExcel : listFbsQualityQualificationRates) {
                  fbsQualityQualificationRateService.save(fbsQualityQualificationRateExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsQualityQualificationRates.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

  /**
  * @Author chenchuang
  * @Description //TODO 保存
  * @Date 2020/11/7 18:07
  * @Param [fbsQualityQualificationRate]
  * @return org.jeecg.common.api.vo.Result<org.jeecg.modules.fbsQualityQualificationRate.entity.FbsQualityQualificationRate>
  */
  @PostMapping(value = "/addData")
  public Result<FbsQualityQualificationRate> addData(@RequestBody FbsQualityQualificationRate fbsQualityQualificationRate){
	  Result<FbsQualityQualificationRate> result=new Result<>();
	  try {
		  fbsQualityQualificationRateService.addData(fbsQualityQualificationRate);
		  result.success("操作成功");
	  } catch (Exception e) {
		  e.printStackTrace();
		  result.error500("操作失败："+e.getMessage());
	  }
	  return result;
  }

  /**
  * @Author chenchuang
  * @Description //TODO 查询未删除的数据
  * @Date 2020/11/7 18:22
  * @Param []
  * @return org.jeecg.common.api.vo.Result<org.jeecg.modules.fbsQualityQualificationRate.entity.FbsQualityQualificationRate>
  */
  @GetMapping(value = "/getDataByDeflag")
  public Result<FbsQualityQualificationRate> getDataByDeflag(){
	  Result<FbsQualityQualificationRate> result=new Result<>();
	  try {
		  LambdaQueryWrapper<FbsQualityQualificationRate> lambdaQueryWrapper=new LambdaQueryWrapper<>();
		  lambdaQueryWrapper.eq(FbsQualityQualificationRate::getDelFlag,"0");
		  List<FbsQualityQualificationRate> fbsQualityQualificationRateList=fbsQualityQualificationRateService.list(lambdaQueryWrapper);
		  if(fbsQualityQualificationRateList!=null&&fbsQualityQualificationRateList.size()>0){
		  	result.setResult(fbsQualityQualificationRateList.get(0));
		  }else{
			  result.setResult(null);
		  }
		  result.success("操作成功");
	  } catch (Exception e) {
		  e.printStackTrace();
		  result.error500("操作失败："+e.getMessage());
	  }
	  return result;
  }

}
